!
subroutine LA15(A, D, Trp, T, Error)
!   A      
!       
!declaration
real, intent(inout):: A(:,:)
real:: D(:)
logical, intent(in):: Trp
integer:: T(:), Error
real, allocatable:: W(:)
real RN, AA, Sum
integer i, j, k, m, p, N
!begin
  N=size(A,1); RN=float(N)
  Error=0
  allocate(W(N))
  do i=1,N;  D(i)=A(i,i); end do
  do p=1, N
    if (Trp) then
      AA=abs(D(p)); m=p
      do k=p+1, N
        if (AA<abs(D(k))) then
          AA=abs(D(k)); m=k
        end if
      end do
      if (m/=p) then
        AA=D(m); D(m)=D(p); D(p)=AA
        !if p>1 then
          do i=1, p-1
            AA=A(i,p); A(i,p)=A(i,m); A(i,m)=AA
          end do
        !end if
        !if p+1<m then
          do i=p+1, m-1
            AA=A(p,i); A(p,i)=A(i,m); A(i,m)=AA
          end do
        !end if
        !if m<N then
          do i=m+1, N
            AA=A(p,i); A(p,i)=A(m,i); A(m,i)=AA
          end do
        !end if
      end if
      T(p)=m
    end if
    if (RN+abs(D(p))==RN) then
      deallocate(W)
      Error=65; return
    end if
    Sum=D(p)
    do k=1, p-1
      W(k)=A(k,p)*D(k)
      Sum=Sum-A(k,p)*W(k)
    end do
    D(p)=Sum
    do j=p+1, N
      Sum=A(p,j)
      do k=1, p-1
        Sum=Sum-A(k,j)*W(k)
      end do
      A(p,j)=Sum/D(p)
    end do
  end do
  if(.not.Trp) then
    do i=1, N-1; T(i)=i; end do
  end if
  T(N)=N
  deallocate(W)
  return
end subroutine LA15
